
// ref: https://umijs.org/config/
export default {
  treeShaking: true,
  routes: [
    {
      path: '/',
      component: '../layouts/index',
      routes: [
        { path: '/', component: '../pages/Download/Download' },
        { path: '/:ci', component: '../pages/Download/Download' },
      ]
    }
  ],
  plugins: [
    // ref: https://umijs.org/plugin/umi-plugin-react.html
    ['umi-plugin-react', {
      antd: false,
      dva: true,
      dynamicImport: false,
      title: '',
      dll: false,
      hd: true,
      routes: {
        exclude: [
          /models\//,
          /services\//,
          /model\.(t|j)sx?$/,
          /service\.(t|j)sx?$/,
          /components\//,
        ],
      },
      headScripts: [
        //react
        '//sp.qn.paqukeji.com/static/react/16.9.0/react.production.min.js',
        //react-dom
        '//sp.qn.paqukeji.com/static/react/16.9.0/react-dom.production.min.js',
        //antd-mobile
        '//sp.qn.paqukeji.com/static/antd-mobile/2.3.1/antd-mobile.min.js',
        // //lottie动画
        // '//sp.qn.paqukeji.com/static/bodymovin/5.6.8/lottie.min.js'
      ],
      //CDN引入
      links: [
        { href: '//sp.qn.paqukeji.com/static/antd-mobile/2.3.1/antd-mobile.min.css', rel: 'stylesheet' }
      ],
    }],
  ],
  lessLoaderOptions: {
    javascriptEnabled: true,
  },
  extraBabelPlugins: [
    ["import", { libraryName: "antd-mobile", style: true }] // `style: true` 会加载 less 文件
  ],
  proxy: {
    '/api-app': {
      //target: 'http://api.starbuds.laylib.com',
      target: 'http://h5.paqukeji.com',
      changeOrigin: true,
      //pathRewrite: { '^/server': '' },
    },
    '/api-common': {
      //target: 'http://api.starbuds.laylib.com',
      target: 'http://h5.paqukeji.com',
      changeOrigin: true,
      //pathRewrite: { '^/server': '' },
    },
    '/wx': {
      target: 'https://api.weixin.qq.com',
      //target: 'http://h5.paqukeji.com',
      changeOrigin: true,
      pathRewrite: { '^/wx': '' },
    },
  },
  hash: true,
  outputPath: './live-download-h5',
  publicPath: '/', // '//sp.qn.paqukeji.com/live-h5/',
  externals: {
    'react': 'React',
    'react-dom': 'ReactDOM',
    'antd-mobile': 'antd-mobile',
    'lottie-web': 'lottie'
  },
  theme: {
    "brand-primary": "#ff4d5cff",
    "color-text-base": "#333",
    "brand-primary-tap": "rgba(255, 77, 92, 0.8)"
  },
}
