import React from 'react'
import { ActivityIndicator, Result, Icon, Flex } from 'antd-mobile'
import styles from './Wrap.less'

export default (props) => {

  const { loading, err, errMsg, empty } = props

  //渲染主体
  const renderContent = () => {
    //加载中
    if (loading) {
      return <ActivityIndicator toast text="加载中" />
    }
    //接口错误
    if (err) {
      return (
        <div className={styles.err}>
          <Result
            img={<Icon type="cross-circle" className={styles['icon-err']} />}
            title="信息错误"
            message={errMsg}
          />
        </div>
      )
    }
    //空页面
    if (empty) {
      return (
        <Flex className={styles.empty} align="center" justify="center">
          <div>
            <img className={styles['icon-empty']} src={require('./assets/icon_empty.png')} />
            <div className={styles.message}>~空数据~</div>
          </div>
        </Flex>
      )
    }
    //正常
    return props.children
  }
  return (
    <div className={styles.wrap}>
      {renderContent()}
    </div>
  )
}