import { stringify } from 'qs';
import request from '@/utils/request';

//获取直播详情
export async function getLiveInfo(params) {
  return request(`/api-app/v1/live/getLiveInfo?${stringify(params)}`);
}

//获取直播详情（游客）
export async function getLiveInfoLite(params) {
  return request(`/api-app/v1/live/getLiveInfoLite?${stringify(params)}`);
}

//禁播
export async function disableAnchor(params) {
  return request('/api-manage/v1/anchor/disableAnchor', {
    method: 'POST',
    body: params,
  });
}

//获取最新版本应用
export async function getAppLatest(params) {
  return request(`/api-common/v1/data/getAppLatest?${stringify(params)}`);
}

//获取内容详情（游客）
export async function getFeedDetailGuest(params) {
  return request(`/api-app/v1/feed/getFeedDetailGuest?${stringify(params)}`);
}

//获取金币充值项目
export async function getCoinRechargeItemsGuest(params) {
  return request(`/api-app/v1/recharge/getCoinRechargeItemsGuest?${stringify(params)}`);
}

//查询用户
export async function getUserByUserNoOrNiceNo(params) {
  return request(`/api-app/v1/user/getUserByUserNoOrNiceNo?${stringify(params)}`);
}

//创建金币充值订单
export async function addCoinRechargeOrderGuest(params) {
  return request('/api-app/v1/recharge/addCoinRechargeOrderGuest', {
    method: 'POST',
    body: params,
  });
}

//创建支付订单
export async function addPayOrderGuest(params) {
  return request('/api-app/v1/pay/addPayOrderGuest', {
    method: 'POST',
    body: params,
  });
}

//获取服务号openId
export async function getOpenId(params) {
  return request(`/api-app/v1/user/getOpenId?${stringify(params)}`);
}