import MD5 from './Security'
import { getQueryString } from './Url'

// 62进制转成10进制
function string62to10(number_code) {
  var chars = '0123456789abcdefghigklmnopqrstuvwxyzABCDEFGHIGKLMNOPQRSTUVWXYZ',
    radix = chars.length,
    number_code = String(number_code),
    len = number_code.length,
    i = 0,
    origin_number = 0;
  while (i < len) {
    origin_number += Math.pow(radix, i++) * chars.indexOf(number_code.charAt(len - i) || 0);
  }
  return origin_number;
}

// 截取渠道id
export const getChannelId = () => {
  const pathname = window.location.pathname
  // 62进制的渠道id
  const _channelId62 = pathname.substr(1)
  return string62to10(_channelId62)
}

export const Base64 = {
  _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
  encode: function (e) {
    var t = "";
    var n, r, i, s, o, u, a;
    var f = 0;
    e = Base64._utf8_encode(e);
    while (f < e.length) {
      n = e.charCodeAt(f++);
      r = e.charCodeAt(f++);
      i = e.charCodeAt(f++);
      s = n >> 2;
      o = (n & 3) << 4 | r >> 4;
      u = (r & 15) << 2 | i >> 6;
      a = i & 63;
      if (isNaN(r)) {
        u = a = 64
      } else if (isNaN(i)) {
        a = 64
      }
      t = t + this._keyStr.charAt(s) + this._keyStr.charAt(o) + this._keyStr.charAt(u) + this._keyStr.charAt(a)
    }
    return t
  },
  decode: function (e) {
    var t = "";
    var n, r, i;
    var s, o, u, a;
    var f = 0;
    e = e.replace(/[^A-Za-z0-9+/=]/g, "");
    while (f < e.length) {
      s = this._keyStr.indexOf(e.charAt(f++));
      o = this._keyStr.indexOf(e.charAt(f++));
      u = this._keyStr.indexOf(e.charAt(f++));
      a = this._keyStr.indexOf(e.charAt(f++));
      n = s << 2 | o >> 4;
      r = (o & 15) << 4 | u >> 2;
      i = (u & 3) << 6 | a;
      t = t + String.fromCharCode(n);
      if (u != 64) {
        t = t + String.fromCharCode(r)
      }
      if (a != 64) {
        t = t + String.fromCharCode(i)
      }
    }
    t = Base64._utf8_decode(t);
    return t
  },
  _utf8_encode: function (e) {
    e = e.replace(/rn/g, "n");
    var t = "";
    for (var n = 0; n < e.length; n++) {
      var r = e.charCodeAt(n);
      if (r < 128) {
        t += String.fromCharCode(r)
      } else if (r > 127 && r < 2048) {
        t += String.fromCharCode(r >> 6 | 192);
        t += String.fromCharCode(r & 63 | 128)
      } else {
        t += String.fromCharCode(r >> 12 | 224);
        t += String.fromCharCode(r >> 6 & 63 | 128);
        t += String.fromCharCode(r & 63 | 128)
      }
    }
    return t
  },
  _utf8_decode: function (e) {
    var t = "";
    var n = 0;
    var c1, c2, c3;
    var r = c1 = c2 = 0;
    while (n < e.length) {
      r = e.charCodeAt(n);
      if (r < 128) {
        t += String.fromCharCode(r);
        n++
      } else if (r > 191 && r < 224) {
        c2 = e.charCodeAt(n + 1);
        t += String.fromCharCode((r & 31) << 6 | c2 & 63);
        n += 2
      } else {
        c2 = e.charCodeAt(n + 1);
        c3 = e.charCodeAt(n + 2);
        t += String.fromCharCode((r & 15) << 12 | (c2 & 63) << 6 | c3 & 63);
        n += 3
      }
    }
    return t
  }
}

// 获取时间
export const getDate = (nDate = (new Date()), fmt = 'yyyy-MM-dd hh:mm:ss') => {
  const sDate = new Date(nDate)
  const dateObj = {
    'M+': sDate.getMonth() + 1,
    'd+': sDate.getDate(),
    'h+': sDate.getHours(),
    'm+': sDate.getMinutes(),
    's+': sDate.getSeconds(),
    'q+': Math.floor((sDate.getMonth() + 3) / 3),
    'S': sDate.getMilliseconds()
  }
  if (/(y+)/.test(fmt)) {
    fmt = fmt.replace(RegExp.$1, (sDate.getFullYear() + '')
      .substr(4 - RegExp.$1.length))
  }
  for (const s in dateObj) {
    if (new RegExp('(' + s + ')').test(fmt)) {
      fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1)
        ? (dateObj[s])
        : (('00' + dateObj[s]).substr(('' + dateObj[s]).length)))
    }
  }
  return fmt
}

export const regIntNumber = /^[1-9]\d*$/
//贵族登记
export const getNobility = (nobleLevelLimit) => {
  let result = ''
  switch (nobleLevelLimit) {
    case 0:
      result = '不限'
      break;
    case 1:
      result = '男爵'
      break;
    case 2:
      result = '子爵'
      break;
    case 3:
      result = '伯爵'
      break;
    case 4:
      result = '侯爵'
      break;
    case 5:
      result = '公爵'
      break;
    case 6:
      result = '国王'
      break;
    case 7:
      result = '皇帝'
      break;

    default:
      break;
  }
  return result
}

// -----------
// ----------- 环境判断类 ----------
// -----------
const USERAGENT = window.navigator.userAgent
//判断微信
export const isWeixin = () => {
  const ua = USERAGENT.toLowerCase();
  return ua.match(/MicroMessenger/i) == 'micromessenger'
}
// 判断安卓
export const isAndroid = () => {
  return USERAGENT.indexOf('Android') > -1 || USERAGENT.indexOf('Linux') > -1; //g
}
// 判断ios
export const isIos = () => {
  return !!USERAGENT.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
}
// 判断是否是在 App 中
export const isApp = () => {
  return USERAGENT.indexOf('com.xike.app') > -1
}

export const isPc = () => {
  var userAgentInfo = navigator.userAgent;
  var Agents = new Array("Android", "iPhone", "SymbianOS", "Windows Phone", "iPad", "iPod");
  var flag = true;
  for (var v = 0; v < Agents.length; v++) {
    if (userAgentInfo.indexOf(Agents[v]) > 0) {
      flag = false;
      break;
    }
  }
  // pc true phone false
  return flag;
}

export const DOWN_MS = 500000

// body 禁止滚动
const preventDefaultFunc = function (e) {
  e.preventDefault()
}
export const setBodyScroll = (isAllow) => {
  const _body = document.body
  if (isAllow) {
    // _body.style.overflow = 'unset' 
    _body.removeEventListener('touchmove', preventDefaultFunc)
    return
  }
  // _body.style.overflow = 'hidden' 
  _body.addEventListener('touchmove', preventDefaultFunc, { passive: false })
}


export const encryptMd5 = MD5.encryptMd5

//默认头像
export const _defaultAvatar = 'http://sp.qn.paqukeji.com/images/default_avatar.png'

//app下载地址统一
let c = getChannelId() // getQueryString('c') || getQueryString('ci') || '0'
// c = (parseInt(c) < 1000 && c !== '4') ? 0 : c
export const _appDownloadUrl = `//starbuds.paqukeji.com/download/${c}` + '?s=1'  //增加渠道号 //starbuds.paqukeji.com/download/渠道号, 主包是0